/* Vinay A. Mahadik (vamahadik fastmail fm), Feb 2006 */

/*
	Build:
	cl /c RE_DLLCodeInj.cpp
	link /DLL RE_DLLCodeInj.obj
*/

#define WIN32_LEAN_AND_MEAN
#include <windows.h>
#include <stdio.h>
#include <string.h>

/* Adjust the following to taste. */
#define EXE_NAME "Sample.exe"
#define BASE_ADDR 0x720000
#define POLL_FREQ 10
#define LOAD_WAIT 1000
#define MAX_PATCH_SIZE 16
unsigned char orig_opcodes[MAX_PATCH_SIZE] =
{
	  0xDE, 0xAD, 0xBE, 0xEF, 0xDE, 0xAD, 0xBE, 0xEF, 0xDE, 0xAD, 0xBE, 0xEF, 0xDE, 0xAD, 0xBE, 0xEF
};

#define WR_FL() WriteFile(hFile, log_buf, nb_towrite, &nb_written, NULL)
#define WR_FL_FLUSH() {\
	WriteFile(hFile, log_buf, nb_towrite, &nb_written, NULL); \
	FlushFileBuffers(hFile); \
}

extern unsigned int first_tick = 0;
SIZE_T num = 0;
char log_buf[4096];
DWORD nb_written;
DWORD nb_towrite;
HANDLE hFile, hProc;
int delta_offset = 0;
DWORD opcodes_start = 0;
DWORD opcodes_end = 0;
DWORD detour_base = 0;
DWORD detour_base_rt = 0;
DWORD detour_shellcode = 0;
DWORD patch_size = 0;

// Equivalent of pushad/popad (without using stack)
unsigned int gpregs[9] = {0}; // Stores EDI, ESI, EBP, EBX, EDX, ECX, EAX, return address!, ESP in that order.

void detour()
{
	{
		__asm
		{
			// Delta offset stuff to make things relocatable.
			call l_detour_base;
l_detour_base:
			pop eax;
			mov detour_base_rt, eax;
		}

		// Is this possible in C?
		__asm
		{
			mov eax, l_detour_base;
			mov detour_base, eax;
			mov eax, l_opcodes_start;
			mov opcodes_start, eax;
			mov eax, l_opcodes_end;
			mov opcodes_end, eax;
			mov eax, l_detour_shellcode;
			mov detour_shellcode, eax;
		}

		// Set to absolute runtime address offsets now.
		delta_offset = detour_base_rt - detour_base;
		opcodes_start += delta_offset;
		opcodes_end += delta_offset; 
		detour_shellcode += delta_offset;

		patch_size = opcodes_end - opcodes_start; // (~6 bytes) adjust MAX_PATCH_SIZE & orig_opcodes accordingly

		// If you run detour(), it will only fill offsets and exit.
		// To go down, you have jmp there directly.
		return; 
	}

	{
l_opcodes_start:
		// this is from the EXE to the DLL
		__asm
		{
			jmp detour_shellcode;
		}
l_opcodes_end:
		__asm nop;
	}

	{
l_detour_shellcode:
		// do all your work and then return to orig code as if nothing happened.
		// Stack and everything else must be just the way it was! "pusha, popa!"

		__asm
		{	// Save state to gpregs array

			mov dword ptr gpregs, EDI;
			mov dword ptr gpregs+4*1, ESI;
			mov dword ptr gpregs+4*2, EBP;
			mov dword ptr gpregs+4*3, EBX;
			mov dword ptr gpregs+4*4, EDX;
			// mov dword ptr gpregs+4*5, ECX; // EAX, ECX are lost anyway
			// mov dword ptr gpregs+4*6, EAX; 
            pop EAX; // pop out return address into EAX
			mov dword ptr gpregs+4*7, EAX;
			mov dword ptr gpregs+4*8, ESP;
		}

		__asm push eax; // If return address of caller is needed
		nb_towrite = sprintf(log_buf, "InjDLL: Tick = %u : ThreadID = %u : Return Addr = 0x%x : ", GetTickCount()-first_tick, GetCurrentThreadId());
		__asm pop eax;
		
		WR_FL();


		// The following logs a vsprintf() like logging function in the exe (Just an illustrative example)
		// poi(esp) = "fmt_str", poi(esp+4) = address on stack where var_args start!

		__asm
		{
			// Do logging stuff (We have var args on stack starting with fmt string)
			lea eax, log_buf;
			push eax;
			call vsprintf; // so we should have stuff in log_buf now
			mov nb_towrite, eax;
		}
		
		WR_FL();

		__asm
		{
			// restore stack
			mov ESP, dword ptr gpregs+4*8;

			// place return address again
			mov EAX, dword ptr gpregs+4*7;
			push EAX;

			// Restore state from gpregs array
			mov EDI, dword ptr gpregs;
			mov ESI, dword ptr gpregs+4*1;
			mov EBP, dword ptr gpregs+4*2;
			mov EBX, dword ptr gpregs+4*3;
			mov EDX, dword ptr gpregs+4*4;
			// mov ECX, dword ptr gpregs+4*5;
			// mov EAX, dword ptr gpregs+4*6;
		}

		__asm 
		{
			{
				// Orig stuff from the EXE (where we pasted the detour jump)
				mov eax, [esp+8];
				mov ecx, [esp+4];
				push eax;
			}

			mov eax, BASE_ADDR + 0x09; // Instruction after the last one above. eax is not used.
			jmp eax;
		}
	}

}

DWORD WINAPI ThreadProc( LPVOID lpParam ) 
{ 
	DWORD gerr;

	for (;;) // poll to see if process has unpacked. we want to start debugging as soon as possible.
	{
		if ( memcmp((const void *)BASE_ADDR, orig_opcodes, MAX_PATCH_SIZE) )
		{
			//sprintf(log_buf, "InjDLL: Bytes don't match yet: 0x%x 0x%x..\n", *((unsigned int *)BASE_ADDR),
			//	*((unsigned int *)(BASE_ADDR+4)));
			//WR_FL();
			Sleep(POLL_FREQ);
		}
		else
			break;
	}

	// Sleep(LOAD_WAIT); // Let process loading complete.
	sprintf(log_buf, "InjDLL: Done unpacking!\n");
	WR_FL();

	// DebugBreak();

	/* Now patch the EXE. */

	if ( !WriteProcessMemory(hProc, (LPVOID)BASE_ADDR, (LPCVOID)opcodes_start, patch_size, &num) || ( num < patch_size) )
	{	
		gerr = GetLastError();
		sprintf(log_buf, "InjDLL: WriteProcessMemory Patch Error: %d 0x%x num = %d\n", gerr, gerr, num);
		WR_FL();
	}

//	Don't close file handle. Let shellcode write to file.
//	if ( hFile )
//		CloseHandle(hFile);
    return 0; 
}

BOOL APIENTRY DllMain( HANDLE hModule, 
                       DWORD  fdwReason, 
                       LPVOID lpReserved
					 )
{
#define MAX_THREADS 1

	unsigned char fn_buf[512] = {0};
    DWORD dwThreadId[MAX_THREADS];
    HANDLE hThread[MAX_THREADS]; 

	double val;
	val = 3.14159; // This is just to "load"?? floating point (R6002 Floating point not loaded error.)

	// DebugBreak();

    switch( fdwReason ) 
    { 
        case DLL_PROCESS_ATTACH:
            break;
		
		default: // nothing to do.
			return TRUE;
    }

	hProc = GetCurrentProcess();

	if ( !GetModuleFileName(NULL, (LPTSTR) fn_buf, sizeof(fn_buf)-1) ) 
	{
		return TRUE; // Can't open file until we filter out processes
	}

	if ( !strstr((const char *)fn_buf, EXE_NAME) )  // Don't do this on other exes
	{
		return TRUE;
	}

	/* Done filtering Process. */

	if ( !first_tick )
		first_tick = GetTickCount();

	hFile = CreateFile(TEXT("dumped_logs"),  
                   GENERIC_WRITE|GENERIC_READ,
                   FILE_SHARE_READ,       // share for reading
                   NULL,                  
                   OPEN_ALWAYS,        
                   FILE_ATTRIBUTE_NORMAL,
                   NULL);                
 
	if (hFile == INVALID_HANDLE_VALUE) 
	{ 
		return TRUE;
	}

	detour(); // Set up shellcode's opcodes_start and opcodes_end variables
	
	if ( !opcodes_start || !opcodes_end || !detour_base || !detour_base_rt || !detour_shellcode )
	{
		sprintf(log_buf, "InjDLL: Offsets fetch failed.\n");
		WR_FL();
		return TRUE;
	}
	
    hThread[0] = CreateThread( 
            NULL,              // default security attributes
            0,                 // use default stack size  
            ThreadProc,        // thread function 
            0,	               // argument to thread function 
            0,                 // use default creation flags 
            &dwThreadId[0]);   // returns the thread identifier 
 
    if (hThread[0] == NULL) 
    {
        return TRUE;
    }

	// If you wait here, the thread sends a THREAD_ATTACH message to the DLL, but since
	// a DLL is non reentrant, the DLL has to exit before it can receive the thread attach, so you deadlock.
	// WaitForMultipleObjects(MAX_THREADS, hThread, TRUE, INFINITE); 

	return TRUE;
}

